'use strict';

exports.__esModule = true;
exports['default'] = createStoreWithReduxables;

var _redux = require('redux');

var _Reduxable = require('./Reduxable');

var _Reduxable2 = _interopRequireDefault(_Reduxable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/**
 * Creates a Redux store that holds the state tree.
 *
 * The only difference with Redux's `createStore` is that it also recognizes
 * the Reduxable instances getting its reducers.
 *
 * @returns {Store} A Redux store that lets you read the state, dispatch actions
 * and subscribe to changes.
 */

function createStoreWithReduxables(reduxable) {
  // TODO: check for Reduxable inhetirance properly
  //       Don't know why `reduxable.constructor.prototype instanceof Reduxable` is not working
  var reducer = typeof reduxable === 'function' ? reduxable : reduxable.reduce;

  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  var store = _redux.createStore.apply(undefined, [reducer].concat(args));
  _Reduxable2['default']._setStore(store);
  return store;
}